<!DOCTYPE html>
<html>
	<head>
		<title>MathJax Dynamic Math Test Page</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var WriteFormula = function(divId, TeX)
				{
					//var HIDEBOX = function () { box.style.visibility = "hidden" }
					//var SHOWBOX = function () { box.style.visibility = "visible" }
					var selector = "#" + divId;
					var selObj = $(selector)
					var queue = MathJax.Hub.queue;
					var math = MathJax.Hub.getAllJax(divId)[0];
					queue.Push(
								function () { selObj.css('visibility','hidden') },
								["resetEquationNumbers",MathJax.InputJax.TeX],
								["Text",math,"\\displaystyle{"+TeX+"}"],
								function () { selObj.css('visibility','visible') }
						);
				}
		</script>
	</head>

	<body>

		<p>
			GF: <input type="text" id="txtDegree" value="2"/> <br />
			Matris: <input type="text" id="txtGeneratorMatrix" value="[[1,1,1,1,1,1,1],[1,0,0,0,1,0,1],[1,1,0,0,0,1,0],[0,1,1,0,0,0,1]]"/>
			<input type="button" id="btnWriteFormula" value="Matrisi Yaz" />
		</p>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputInfo">$${}$$</div>
		</div>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputGenerator">$${}$$</div>
		</div>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputGeneratorSF">$${}$$</div>
		</div>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputParityCheckSF">$${}$$</div>
		</div>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputCodewords">$${}$$</div>
		</div>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputCosets">$${}$$</div>
		</div>

		<div class="box" id="box" style="visibility:hidden;">
		<div id="MathOutputWeightCounter">$${}$$</div>
		</div>

		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnWriteFormula") {
						var aggregate = function(arr, seed, func)
							{
								var accumulate = seed;
								for(var i = 0; i < arr.length; i++)
									{
										accumulate = func(accumulate, arr[i]);
									}
								return accumulate;
							}

						var q = parseInt($('#txtDegree').val());
						var arr= eval($('#txtGeneratorMatrix').val());
						var mat = new Matrix(arr);
						var processor = new MatrixCalculator(q);
						var matGen = new MatrixGenerator(q);
						var code = new ErrorCorrectingCode(mat, q);

						var info = "q=" + code.q;
						info += "\\\\ n=" + code.n;
						info += "\\\\ k=" + code.k;
						info += "\\\\ M=" + code.M;
						info += "\\\\ d=" + code.d;
						info += "\\\\ t=" + code.t;
						WriteFormula("MathOutputInfo", info);

						WriteFormula("MathOutputGenerator", "G=" + code.Generator.ToLatex());
						WriteFormula("MathOutputGeneratorSF", "G_{sf}=" + code.GeneratorSF.ToLatex());
						WriteFormula("MathOutputParityCheckSF", "H^T=" + code.PartiyCheckSF.Transpose().ToLatex());

						// Codewords begin
						var codeWordsText = "\\begin{array}{c|cll} word & codeword & support \\ vector \\\\ \\hline";
						for (var i = 0; i < code.M; i++) {

							var sfw = code.CalculateCodeword(code.SourceWords[i], code.GeneratorSF);

							var word_orj = code.SourceWords[i].Text;
							var word_cod = code.CodeWords[i].Text;
							var word_spv = "S=" + code.CodeWords[i].supportText;
							var word_min = (code.CodeWords[i].isMinimalCodeword == true ? "minimal" : "not \\ minimal");
							//codeWordsText +=  + "\\rightarrow" +  + " | " + ;
							codeWordsText += word_orj + "&" + word_cod + "&" + word_spv + "&" + word_min;
							if(i != code.M-1)
								codeWordsText += "\\\\";
						}
						codeWordsText += "\\end{array}";
						WriteFormula("MathOutputCodewords", codeWordsText);
						// Codewords end

						// Cosets begin
						var syndromeCount = Math.pow(code.q, code.n-code.k);
						var syndromeWords = code.FindWords(code.q, code.n-code.k);
						var allWords = code.FindWords(code.q, code.n);
						var syndromeCodes = [];
						for (var i = 0; i < syndromeCount; i++)
							syndromeCodes[syndromeWords[i].Text] = [];

						for (var i = 0; i < allWords.length; i++) {
							var word = allWords[i];
							var syd = new CodeWord(processor.Multiply(word.Data, code.PartiyCheckSF.Transpose()));
							syndromeCodes[syd.Text].push(word);
						}

						var maxWordCount = 0;
						var syndromeCosetText = "";
						for (var i = 0; i < syndromeCount; i++) {
							var syd = syndromeWords[i];
							var words = syndromeCodes[syd.Text];
							var maxWordCount = Math.max(maxWordCount, words.length);

							for (var j = 1; j < words.length; j++) {
								if (words[0].weight > words[j].weight) {
									var tmp = words[0];
									words[0] = words[j];
									words[j] = tmp;
								}
							}

							line = syd.Text + "&";
							for (var j = 0; j < words.length; j++) {
								line += words[j].Text;
								if (j != words.length - 1)
									line += "&";
							}
							if(i != syndromeCount-1)
								line += "\\\\";
							syndromeCosetText += line;
						}

						syndromeCosetText = "\\begin{array}{c|c|"+ 'c'.repeat(maxWordCount-1) + "} Syndrome & Coset \\ leader " + '& '.repeat(maxWordCount-1) + "\\\\ \\hline " + syndromeCosetText;
						syndromeCosetText += "\\end{array}";
						WriteFormula("MathOutputCosets", syndromeCosetText);
						// Cosets end

						// weight counter begin
						var weights = [];
						for (var i = 0; i <= code.n; i++)
							weights[i] = 0;
						for (var i = 0; i < code.M; i++)
							weights[code.CodeWords[i].weight] += 1;
						var weightCounterText = "";
						for (var i = 0; i <= code.n; i++){
							if (weights[i] == 0)
								continue;
							weightCounterText += weights[i];
							if(code.n-i != 0)
								weightCounterText += "x^"+(code.n-i);
							if(i != 0)
								weightCounterText += "y^" + i;
							weightCounterText += "+";
						}
						if(weightCounterText.length > 0)
							weightCounterText = weightCounterText.substring(0,weightCounterText.length-1);
						// weight counter end

						WriteFormula("MathOutputWeightCounter", "W_C(x,y)=" + weightCounterText)
					}
				});
			});
		</script>

	</body>
</html>
